//chemesis2.1
//PurkCell.g - tutorial on modeling biochemical reactions
//Top level file for simulating mGluR to IP3 reactions in Purkinje cells
// similar to Tutorial08.g, but explicitly models glutamate*/
/*Matches Tutorial08.g if using enzyme (not mmenz) for PIP2IP3, with or without IP3 deg, but with no GaGTP deg */

//include parameters and function definition
include param.g
include mGlu-IP3-enz.g

//neutral object glutamate will hold a constant glu concentration
create neutral purkcell
ce purkcell
create neutral glutamate
ce ..

//invoke the function to create molecule pools and reactions
mGluIP3 purkcell glutamate {Volume} {um}

//graphs to plot some stuff
include graphs.g
graphs purkcell

//initialize by simulation for 100 ms
setclock 0 0.0001
setclock 1 0.001
reset
step 1000

// set glutmate concentration to 100 and simulate another 100 ms

setfield purkcell/glutamate z 100
step 1000

// decrease glutamate concentration back to 0, and continue simulation

setfield purkcell/glutamate z 0
//step 18000


