//chemesis2.1
/* mGlu-IP3-enz.g */

/* A = kbprod  B= kfsubs */

function mGluIP3 (pkc, Glu, Vol, ConcUnits)
str pkc
str Glu
float Vol, ConcUnits
echo {Vol} {ConcUnits}

/*####################setting up reactions################################*/
/* Glu=gbar_glu*heav(t-tstart_g)*heav(tstart_g+dur_glu-t)
 
 mGluR=K_mGlu-Glu_mGluR-GG_mGluR
 G=K_G-aG-GG_mGluR-aPLC_aG
 PLC=K_PLC-aPLC_aG-aPLC_PIP2
 PIP2=K_PI-DAG-aPLC_PIP2

 Glu + mGluR <--> Glu-mGluR (uses D3)
 Glu-mGLuR + G <-> G-Glu-mGluR -> aG + Glu-mGluR (uses D5, D6)
 aG + PLC <-> aPLC-aG (uses G2)
 aPLC + PIP2 <-> aPLC-PIP2 -> aPLC +IP3+ DAG (which to use? G6 ?)
 aG -> G (uses D7)
 IP3 -> dIP3 (uses G8 and G9)
 DAG -> dDAG
*/
/* Implement reactions as follows: 1. create conserve pools */

create conservepool {pkc}/mGluRtot	/* pool of mGluR */
setfield {pkc}/mGluRtot Cinit {K_mGluR} Ctot {K_mGluR} volume {Vol} units {ConcUnits}

create conservepool {pkc}/Gtot /* pool of G protein*/
setfield {pkc}/Gtot Cinit {K_G} Ctot {K_G} volume {Vol} units {ConcUnits}

create conservepool {pkc}/PLCtot	/* pool of PLC */
setfield {pkc}/PLCtot Cinit {K_PLC} Ctot {K_PLC} volume {Vol} units {ConcUnits}

create conservepool {pkc}/PIP2tot /* pool of PIP2 substrate */
setfield {pkc}/PIP2tot Cinit {K_PIP2} Ctot {K_PIP2} volume {Vol} units {ConcUnits}

/* 2. create rxnpools, reaction pools are everything above except the
conserve pools and in addition DAG */

create rxnpool {pkc}/Glu_mGluR /* pool of active mGlu */
setfield  {pkc}/Glu_mGluR vol {Vol} Cinit 0.00016 units {ConcUnits}

create rxnpool {pkc}/aG /*pool of active aG */
setfield {pkc}/aG vol {Vol} Cinit 0.0007 units {ConcUnits}

create rxnpool {pkc}/aPLC_aG /*pool of active PLC */
setfield {pkc}/aPLC_aG vol {Vol} Cinit 0.0035 units 1

create rxnpool {pkc}/IP3           /* pool of IP3 */
setfield {pkc}/IP3 vol {Vol} Cinit 0.1 units {ConcUnits}

create rxnpool {pkc}/IP3deg           /* pool of degraded IP3 */
setfield {pkc}/IP3deg vol {Vol} units {ConcUnits}

/* ############################################################## */

/* 3. create all reactions */

/* Glu + mGluR <--> Glu-mGluR (uses D3) */
create reaction {pkc}/mGluR_rxn
setfield {pkc}/mGluR_rxn kf {D3f} kb {D3b}
addmsg {pkc}/{Glu} {pkc}/mGluR_rxn SUBSTRATE z
addmsg {pkc}/mGluRtot {pkc}/mGluR_rxn SUBSTRATE Conc
addmsg {pkc}/Glu_mGluR {pkc}/mGluR_rxn PRODUCT Conc
addmsg {pkc}/mGluR_rxn {pkc}/Glu_mGluR RXN2 kfsubs kbprod
addmsg {pkc}/Glu_mGluR {pkc}/mGluRtot CONC Conc

/* Glu-mGluR + Gtot <-> GGlu-mGluR -> Ga + Glu-mGluR + Gbg */
/*create mmenz {pkc}/GGlu_mGluR
setfield {pkc}/GGlu_mGluR Vmax {VmggluR} Km {KmggluR}
addmsg {pkc}/Gtot {pkc}/GGlu_mGluR SUBSTRATE Conc
addmsg {pkc}/Glu_mGluR {pkc}/GGlu_mGluR ENZ Conc
addmsg {pkc}/GGlu_mGluR {pkc}/aG RXN0 product */
create enzyme {pkc}/GGlu_mGluR
setfield {pkc}/GGlu_mGluR kf {kfggluR} kb {kbggluR} kcat {kcatggluR} units {ConcUnits} vol {Vol}
addmsg {pkc}/Gtot {pkc}/GGlu_mGluR SUBSTRATE Conc
addmsg {pkc}/Glu_mGluR {pkc}/GGlu_mGluR ENZ Conc
addmsg {pkc}/GGlu_mGluR {pkc}/aG RXN0MOLES deltacat
addmsg {pkc}/GGlu_mGluR {pkc}/Glu_mGluR RXN2 deltaenz kfsubs
addmsg {pkc}/GGlu_mGluR {pkc}/Gtot CONC complex_conc
addmsg {pkc}/GGlu_mGluR {pkc}/mGluRtot CONC complex_conc

/* aG + PLC <-> aPLC-aG (uses G2) */
create reaction {pkc}/PLC_rxn
setfield {pkc}/PLC_rxn kf {kfgaplc} kb {kbgaplc}
addmsg {pkc}/aG {pkc}/PLC_rxn SUBSTRATE Conc
addmsg {pkc}/PLCtot {pkc}/PLC_rxn SUBSTRATE Conc
addmsg {pkc}/aPLC_aG {pkc}/PLC_rxn PRODUCT Conc
addmsg {pkc}/PLC_rxn {pkc}/aG RXN2 kbprod kfsubs 
addmsg {pkc}/PLC_rxn {pkc}/aPLC_aG RXN2 kfsubs kbprod 
addmsg {pkc}/aPLC_aG {pkc}/PLCtot CONC Conc

/* aPLC-aG + PIP2 <-> aPLC-PIP2 -> aPLC-aG+IP3+ DAG */
//This one uses mmenz
/*create mmenz {pkc}/pip2ip3
setfield {pkc}/pip2ip3 Vmax {Vmplc} Km {Kmplc}
addmsg {pkc}/aPLC_aG {pkc}/pip2ip3 ENZ Conc
addmsg {pkc}/PIP2tot {pkc}/pip2ip3 SUBSTRATE Conc
addmsg {pkc}/pip2ip3 {pkc}/IP3 RXN0 product*/
//this one uses enzyme
create enzyme {pkc}/pip2ip3
setfield {pkc}/pip2ip3 kf {kfplc} kb {kbplc} kcat {Vmplc} units {ConcUnits} vol {Vol}
addmsg {pkc}/aPLC_aG {pkc}/pip2ip3 ENZ Conc
addmsg {pkc}/PIP2tot {pkc}/pip2ip3 SUBSTRATE Conc
addmsg {pkc}/pip2ip3 {pkc}/IP3 RXN0MOLES deltacat
addmsg {pkc}/pip2ip3 {pkc}/aPLC_aG RXN2 deltaenz kfsubs
addmsg {pkc}/pip2ip3 {pkc}/Gtot CONC complex_conc
addmsg {pkc}/pip2ip3 {pkc}/PLCtot CONC complex_conc
addmsg {pkc}/pip2ip3 {pkc}/PIP2tot CONC complex_conc

/*  aG -> G (uses D7) */
create reaction {pkc}/deG_rxn  /* daG/dt=-kaGdecay aG, degradation for aG */
setfield {pkc}/deG_rxn kf {kaGdecay} kb 0 /* degradation for aG */
addmsg {pkc}/deG_rxn {pkc}/aG RXN1 kfsubs 

/* IP3 -> dIP3 (uses G8 and G9) */
create reaction {pkc}/IP3_rxn    /* degradation for IP3 */
setfield {pkc}/IP3_rxn kf {kdegIP3} kb 0 /* degradation for IP3*/
//setfield {pkc}/IP3_rxn kf 0
addmsg {pkc}/IP3 {pkc}/IP3_rxn SUBSTRATE Conc 
addmsg {pkc}/IP3deg {pkc}/IP3_rxn PRODUCT Conc 
addmsg {pkc}/IP3_rxn {pkc}/IP3deg RXN0 kfsubs 
addmsg {pkc}/IP3_rxn {pkc}/IP3 RXN1 kfsubs 

/*Last set of messages is quantities from rxnpools to conservepools*/

/* G=K_G-aG-aPLC_aG */
addmsg {pkc}/aG {pkc}/Gtot CONC Conc
addmsg {pkc}/aPLC_aG {pkc}/Gtot CONC Conc

/* PIP2=K_PI-IP3-degradIP3 */
addmsg {pkc}/IP3 {pkc}/PIP2tot  CONC Conc
//addmsg {pkc}/IP3deg {pkc}/PIP2tot  CONC Conc 

useclock {pkc}/# 0
setmethod {pkc}/# -1

end

















